/*
contiene tutte le routine per la  gestione dei sensori per le gare explorer
*/

/*CmpCal ******************************************************************************
procedura calibrazione bussola
si posiziona sui quattro punti cardinali e scrive nel registro di calibrazione
*/

void CmpCal (void)
{
   BeepCount=6;
   InitFlag = 0;		// esce dallo stato init
		
	// ---- init movimento
	FlagBumpers = 1;  // disattiva bumpers
	FlagEye=0;        // sensori IR disabilitati
	FlagLight=0;      // sensori luce disabilitati
	FlagSound=0;      // sensori suono disabilitati
   FlagGas=0;        // sensori gas disabilitati
	TimerBumpers = 0; // bumpers disabilitati per 1Sec 
	Space2RunFlag = 0;// reset di qualsiasi routine di movimento
	// fermo per 5 sec poi parte calibrazione
        PathSeq [0] = 20;  // fermo 10 sec
        PathSeq [1] = 23;  // fermo 5 secondi e calibra bussola
        PathSeq [2] = 14;  // gira 90
        PathSeq [3] = 23;  // fermo 5 secondi e calibra bussola
        PathSeq [4] = 14;  // gira 90
        PathSeq [5] = 23;  // fermo 5 secondi e calibra bussola
        PathSeq [6] = 14;  // gira 90
        PathSeq [7] = 23;  // fermo 5 secondi e calibra bussola
        PathSeq [8] = 14;  // gira 90
        PathSeq [9] = 20;  // fermo 10 sec
        PathSeq [10] = 0;  // fine sequenza 
        PathSeqPointer = 0;// inizializza sequenza  
           
        En=1; 			// avvia motori
	TimerLcd=LcdCycle;		// tempo tra le visualizzazioni del display
	LcdInitStatus=0;	      // azzera contatore stati init LCD
   LcdPutCharFlag=0;	      // azzera trasmissione byte su LCD
   LcdStringPtr=0xFF;      // disabilita LcdStringPut
   LcdStatus=0;            // parte dal primo passo del ciclo
	DisplayStatus=2;			// visualizza bussola

	LedRossoOFF;				// led spenti
	LedGialloOFF;
	LedVerdeOFF;   
	LcdPutChar (0x01, 0, 4);// clear display

   
} // CmpCal
/**************************************************************************************/

/*CmpRead *****************************************************************************
Legge il valore attuale della bussola tramite I2C
viene chiamata ogni x ms e solo se il buffer I2c e' vuoto
se il flag = 0 avvia la lettura e alza il flag
quando il buffer sara' di nuovo vuoto la lettura e' terminata
*/

void CmpRead (void)
{
   if (FlagCmpReg15) 
   {// e' nella fase di calibrazione, deve scrivere il valore 255 nel registro 15
    // in  corrispondenza di ogni punto cardinale
      I2c[CmpPtr].Flag.Tx =2;	      // due byte da trasmettere
		I2c[CmpPtr].TxBuff[0] = 15 ;  // scrive nel registro 15
		I2c[CmpPtr].TxBuff[1] = 255 ; // il valore 255 
      FlagCmpReg15=0; // torna nella situazione normale
   }
   else
   {
      if (!FlagCmp)
      {// la prima volta che viene chiamata avvia la lettura I2c
       // scrive numero registro da leggere e poi lo legge
         I2c[CmpPtr].Flag.Tx = 1;	// un byte da trasmettere
		   I2c[CmpPtr].TxBuff[0] = 1 ;// chiede il valore del registro 1
	      I2c[CmpPtr].Flag.Rx = 1;	// un byte da leggere
         FlagCmp=1;                 // attende fine lettura
      }
      else
	   {// finita la lettura resetta flag e timer, verra' chiamata al prossimo ciclo
         TimerCmp=CmpCycle;
         FlagCmp=0;
         CmpBearing=I2c[CmpPtr].RxBuff[0];   // legge il valore dal buffer
      }
   }
     
    
} // CmpRead
/**************************************************************************************/

/*TargetOk ****************************************************************************
Segnala che ha raggiunto l'obiettivo Target:
1 = gas		LedRosso
2 = luce		LedVerde
3 = suono	LedGiallo

	ferma n secondi
   accende il led Target
   suona il buzzer
  	disabilita i sensori per un periodo sufficiente a ripartire dalla sorgente
   gira + o - 90 
   riparte
*/

void TargetOk (char Target)
{
	/*	
		da notare che tutte le manovre non sono eseguite in sequenza
		ma sono impostate per essere gestite in parallelo dal main
	*/
		BeepCount = Target * 2; 	// suona Target beep	
		TimerBeep = BeepTime;		// reset tempo beep
		TimerStop = TimeMotStopTarget;	// pausa motori per N Sec
		FlagStop = 1;  						// abilita routine Stop motori
		FlagTargetLight=1;					// riabilita tutti i sensori	  
		FlagTargetSound=1;					// eventualmente ancora disabilitati	  
		FlagTargetGas=1;	  
		
		// si sfrutta la routine Stop motori anche per la temporizzazione dei led
		// verrannno spenti prima di riavviare i motori: si risparmia un timer
		
		switch (Target)   // quale quale obiettivo ha raggiunto?
         {
            case 1:                // gas
                  LedRossoON;
						FlagTargetGas = 0;
						TimerSensor = TimeDisSensGas;	// reset timer disabilitazione sensori
	
						// disabilita routine sensori gas per il tempo necessario
						// ad allontanarsi.
                  break;
			
				case 2:                // luce
                  LedVerdeON;
						FlagTargetLight = 0;	
						TimerSensor = TimeDisSensLight;	// reset timer disabilitazione sensori
						// disabilita routine sensori luce per il tempo necessario
						// ad allontanarsi. 
                  break;

				case 3:                // suono
						LedGialloON;
						FlagTargetSound = 0;	
						TimerSensor = TimeDisSensSound;	// reset timer disabilitazione sensori
						// disabilita routine sensori suono per il tempo necessario
						// ad allontanarsi.
                  break;
            
            default: 
                  LedVerdeOFF;   // a default spegne tutti i led
                  LedRossoOFF;
                  LedGialloOFF;                  
                  break;
         }

 		// cambia direzione
 		      Space2RunFlag = 0; // reset di qualsiasi routine di movimento
       		PathSeq [0] = 2;   // indietro n cm
            PathSeq [1] = 50;  // gira 90 o -90 randomicamente 
            PathSeq [2] = 255; // cammina avanti a velocita' costante
            PathSeq [3] = 0;   // fine sequenza 
            PathSeqPointer = 0;// inizializza sequenza
	
} // TargetOk
/**************************************************************************************/

/*SegueLuce ****************************************************************************
se la luce e' piu' forte a destra, gira a destra
se e' piu' forte a sinistra, gira a sinistra
altrimenti va dritto
*/

void SegueLuce (void)
{
		if ((FrLVal > FrCVal) && (FrLVal > FrRVal)) // la luce e' a sinistra
			{	// gira a sinistra	
				FlagTargetLight = 0;	// disabilita routine sensori luce fino a fine manovra 
				TimerSensor = TimeDisSensLight;// reset timer disabilitazione sensori
				Space2RunFlag = 0;   // reset di qualsiasi routine di movimento
  		     	PathSeq [0] = 9;     // -10
  		     	PathSeq [1] = 200;   // cammina avanti a velocita' ridotta
  		     	PathSeq [2] = 254;   // riabilita routine sensori luce
  		     	PathSeq [3] = 0;     // fine sequenza
  		     	PathSeqPointer = 0;  // inizializza sequenza 
			}
		if ((FrRVal > FrCVal) && (FrRVal > FrLVal)) // la luce e' a destra
			{	// gira a destra
				FlagTargetLight = 0;	// disabilita routine sensori luce fino a fine manovra 
				TimerSensor = TimeDisSensLight;// reset timer disabilitazione sensori				
      		Space2RunFlag = 0;   // reset di qualsiasi routine di movimento
  		     	PathSeq [0] = 8;     // 10
  		     	PathSeq [1] = 200;   // cammina avanti a velocita' ridotta
  		     	PathSeq [2] = 254;   // riabilita routine sensori luce
  		     	PathSeq [3] = 0;     // fine sequenza
  		     	PathSeqPointer = 0;  // inizializza sequenza 
			}		
		// se la luce non e' ne a destra ne a sinistra, allora prosegue dritto
            DesSpeedR=lowSpeed; // ma approccia l'ostacolo a velocita' bassa
            DesSpeedL=lowSpeed;
			
} // SegueLuce
/**************************************************************************************/


/*Light ********************************************************************************
Controllo sensori di luce a fotoresistenze
Il valore letto e'  quello fornito da ReadAD()

if FrL>Light2 or FrC>Light2 or FrR>Light2; un sensore ha superato la seconda soglia il
														 robot e' vicino alla sorgente luminosa
	if (distanza dall'ostacolo < TargetDist); se la distanza dalla luce rientra nei valori
															imposti dal regolamento
			segnala "obiettivo raggiunto"
   altrimenti 
   		gira verso la luce
   	
altrimenti		
		if FrL>Light1 or FrC>Light1 or FrR>Light1; un sensore ha superato la prima soglia
			if FrL>FrC and FrL>FrR
				gira 10 a sinistra inseguendo la luce
			if FrR>FrC and FrR>FrL
				gira 10 a destra inseguendo la luce
*/

void Light(void)
{
  
if ((FrLVal>=Light2)||(FrCVal>=Light2)||(FrRVal>=Light2)) 
// la sorgente di luce e' vicina
{
	if (
		 ((EyeLlVal>=TargetDist) && (FrLVal>=Light2))||
		 ((EyeLfVal>=TargetDist) && (FrCVal>=Light2))||
		 ((EyeRfVal>=TargetDist) && (FrCVal>=Light2))||
		 ((EyeRlVal>=TargetDist) && (FrRVal>=Light2))
		)
	// se vede molta luce da un lato e dallo stesso lato rivela 
	// un ostacolo alla distanza stabilita
	{
		if (DebounceLight >= DebounceLightCount)
		// solo dopo aver rivelato alcuni segnali positivi consecutivi
		// conferma l'obiettivo, serve ad evitare falsi segnali
		{
			TargetOk(2);	// segnala che ha raggiunto una sorgente di luce
			DebounceLight = 0; // resetta il contatore debounce
		}
		else
		{
			DebounceLight++;
			DesSpeedR=lowSpeed; // rallenta in vicinanza dell'ostacolo
         DesSpeedL=lowSpeed;

		}
	}
	else
	// e' ancora fuori dal cerchio di "bersaglio raggiunto", insegue la luce
	{
		DebounceLight = 0; // resetta il contatore debounce		
		SegueLuce();
	}	
}
else
// la luce non e' vicina
{
	if ((FrLVal>=Light1)||(FrRVal>=Light1)) 
	// per e' stata individuata dai sensori laterali
	// se e' stata rivelata dal sensore centrale, prosegue dritto
	{
		DebounceLight = 0; // resetta il contatore debounce		
		SegueLuce();
	}
}

FlagLight = 0; // la routine si auto-disabilita appena eseguita
      		   // sara' la routine ReadAD a sbloccarla appena terminata una nuova misura
   
} // Light
/**************************************************************************************/

/*Sound ********************************************************************************
Controllo sensore di suono

il circuito per la rivelazione del suono miscela il segnale proveniente dai tre microfoni,
filtra i rumori ed invia il segnale utile al tone decoder.
Un debouncer SW sull'uscita (digitale) del tone decoder, filtra eventuali falsi allarmi

*/

void Sound(void)
{
	if (
		 ((EyeLlVal>=TargetDist) && (!SoundIn))||
		 ((EyeLfVal>=TargetDist) && (!SoundIn))||
		 ((EyeRfVal>=TargetDist) && (!SoundIn))||
		 ((EyeRlVal>=TargetDist) && (!SoundIn))
		)
	// ha rivelato il suono ed e' vicino all'obiettivo
	{
  		if (DebounceSound >= DebounceSoundCount)
		// solo dopo aver rivelato alcuni segnali positivi consecutivi
		// conferma l'obiettivo, serve ad evitare falsi segnali
		{
			TargetOk(3);	// segnala che ha raggiunto una sorgente di suono
			DebounceSound = 0; // resetta il contatore debounce
		}
		else
		{
			DebounceSound++;
			DesSpeedR=lowSpeed; // rallenta in vicinanza dell'ostacolo
         DesSpeedL=lowSpeed;
		}
	}
	else
	// non rivela suono oppure e' ancora fuori dal cerchio di "bersaglio raggiunto"
	{
		DebounceSound = 0; // resetta il contatore debounce		
	}	

FlagSound = 0; // la routine si auto-disabilita appena eseguita
      		   // sara' la routine ReadAD a sbloccarla appena terminata una
      		   // nuova misura con la stessa temporizzazione della routine gas
   
} // Sound
/**************************************************************************************/


/*Gas *********************************************************************************
Controllo sensori di gas
Il valore letto e'  quello fornito da ReadAD()

il circuito per la rivelazione del gas miscela il segnale proveniente dai due TGS822
*/

void Gas(void)
{
	if (GasVal > GasOn)
	// ha rivelato una concentrazione di gas superiore alla soglia impostata
	{
		TargetOk(1);	// segnala che ha raggiunto una sorgente di gas
	}

FlagGas = 0; // la routine si auto-disabilita appena eseguita
      		 // sara' la routine ReadAD a sbloccarla appena terminata una nuova misura
   
} // Gas
/**************************************************************************************/


/*Eye *********************************************************************************
Controllo sensori di prossimita' ad IR
Questa routine ha priorita' bassa rispetto alle altre routine di movimento
viene quindi eseguita solo se non ci sono manovre in atto, anche se innescate
dalla routine stessa
   se Space2RunFlag = 1, e' ancora in esecuzione una singola routine di movimento
   se PathSeq[PathSeqPointer] = 0 -> fine sequenza routines di movimento (EOL)
   se FlagStop = 1 -> la routine Stop ha fermato i motori
Il valore letto e'  quello fornito da ReadAD()

sono prese in considerazione due soglie di allarme
sotto LowDist il bot comincia a rallentare dalla velocita' constSpeed fino a lowSpeed
sotto MinDist gira in senso opposto al lato dell'ostacolo rivelato
tra le due soglie la velocita' e' calcolata secondo la formula
varSpeed=(MinDist-EyeXVal)*(constSpeed-lowSpeed)/(MinDist-LowDist)+lowSpeed;


// ATTENZIONE: a tensione minore corrisponde distanza maggiore
 
----------------------------------------------------------------------------------------
lettura sensori  IR Sharp GP2D120
distanza dal paraurti

distanza    cm:25 24 23 22 21 20 19 18 17 16 15 14 13 12 11 10 09 08 07 06 05 04 03 02
lettura AD hex:10 11 13 14 16 18 1a 1e 20 24 26 2b 30 33 36 3b 3f 46 4e 5a 66 77 8d a2   

sotto i 2cm la  tensione ricomincia a  scendere.
----------------------------------------------------------------------------------------
*/

void Eye(void)
{
int varSpeed;	// velocita' di approccio, variabile in funzione della distanza dall'ostacolo
char EyeRVal;	// valore attuale del rivelatore IR destro
char EyeLVal; 	// valore attuale del rivelatore IR sinistro
char GiraSX;	// angolo di cui girare
char GiraDX;	// angolo di cui girare

if (EyeRlVal > EyeRfVal)    // prende in considerazione solo il sensore destro piu' vicino all'ostacolo
{
   EyeRVal = EyeRlVal; 	// sensore laterale
   GiraSX = 9;				// 10 gradi a sinistra
}
else
{
   EyeRVal = EyeRfVal;	// sensore frontale
   GiraSX = 13;				// 45 gradi a sinistra
}

if (EyeLlVal > EyeLfVal)    // prende in considerazione solo il sensore sinistro piu' vicino all'ostacolo
{
   EyeLVal = EyeLlVal;	// sensore laterale
   GiraDX = 8;				// 10 gradi a destra
}
else
{
   EyeLVal = EyeLfVal;	// sensore frontale
   GiraDX = 12;				// 45 gradi a destra
}


if ((EyeRVal < LowDist) && (EyeLVal < LowDist))	// ostacolo a distanza maggiore di LowDist 
{
	 DesSpeedR=constSpeed; // a default cammina a velocita' costante
    DesSpeedL=constSpeed; // a default cammina a velocita' costante
}

else	// ostacolo a distanza minore di LowDist da uno dei due lati

{
	Space2RunFlag = 0; // reset di qualsiasi routine di movimento	
	if ((EyeRVal < MinDist) && (EyeLVal < MinDist))	// ostacolo a distanza compresa tra LowDist e MinDist 
	{
		//calcola la velocita' di approccio in funzione della distanza dall'ostacolo
		if (EyeRVal >= LowDist) varSpeed=(MinDist-EyeRVal)*(constSpeed-lowSpeed)/(MinDist-LowDist)+lowSpeed;
		if (EyeLVal >= LowDist) varSpeed=(MinDist-EyeLVal)*(constSpeed-lowSpeed)/(MinDist-LowDist)+lowSpeed;
		
		if (varSpeed > constSpeed) varSpeed=constSpeed;
		if (varSpeed < lowSpeed  ) varSpeed=lowSpeed;

		DesSpeedR=varSpeed; // cammina a velocita' di approccio
     	DesSpeedL=varSpeed; // cammina a velocita' di approccio
	}
	
	else	// ostacolo a distanza minore di MinDist da uno dei due lati
	
	{
		if (EyeRVal > MinDist)	//prossimita' a destra -> gira a sinistra
		{
    		   PathSeq [0] = 3;     // indietro 0,1mm 		      
  		      PathSeq [1] = GiraSX;// -10 se sensore laterale, -45 se frontale
  		      PathSeq [2] = 255;   // cammina avanti a velocita' costante
  		      PathSeq [3] = 0;     // fine sequenza
  		      PathSeqPointer = 0;  // inizializza sequenza 
  		}                
                     
		if (EyeLVal > MinDist)	//prossimita' a sinistra -> gira a destra
		{
    		   PathSeq [0] = 3;     // indietro 0,1mm
   		   PathSeq [1] = GiraDX;// 10 se sensore laterale, 45 se frontale
       		PathSeq [2] = 255;   // cammina avanti a velocita' costante
      	   PathSeq [3] = 0;     // fine sequenza 
      		PathSeqPointer = 0;  // inizializza sequenza                  
		}
	}
}

FlagEye = 0; // la routine si auto-disabilita appena eseguita
      		 // sara' la routine ReadAD a sbloccarla appena terminata una nuova misura

} // Eye
/**************************************************************************************/

/*ReadAD ******************************************************************************
legge le porte A/D in sequenza e mette i valori letti nelle rispettive variabili
la lettura delle porte analogiche richiede alcune pause e l'attesa di un flag di 
conferma. Particolare cura va quindi posta per effettuare questi ritardi senza 
coinvolgere le temporizzazioni delle altre routine, anche in questo caso si fara' 
ricorso a flag e variabili globali.

Quando e' passato il tempo di attesa Tacq, questa routine viene chiamata ad ogni
ciclo  di main. 
La sequenza di operazioni per la lettura A/D e' scandita da un flag di stato:

TimerAD>timeout   FlagAD         ADGO     Stato
  0                 x             x       Tacq o primo ciclo dopo boot
  1                 0             0       Passato Tacq, si avvia conversione
  1                 1             1       Conversione avviata, attesa ADGO
  1                 1             0       Conversione effettuata, lettura valore, 
                                          reset timer e stato, imposta nuova lettura
*/

void ReadAD(void)
{
// le porte da leggere sono: EyeRl, EyeLl, EyeRf, EyeLf, FrR, FrL, FrC

unsigned int i = 0; // contatore generico
#define MaskRead  0b00111100  // per leggere la porta in uso su ADCON0
#define MaskClear 0b11000011  // per resettare la porta in uso su ADCON0 

if (!FlagAD)           // primo step: e' appena passato Tacq
{
   ADCON0bits.GO_DONE = 1;     // avvio conversione
   FlagAD = 1;         // passa allo  stato 2
}

else                   // secondo step: in attesa fine conversione
{                
   if (!ADCON0bits.GO_DONE)  // terzo step, quando GO_DONE torna = 0 -> conversione finita
                       // per inserire altre porte da leggere: aggiungere "case"
   {                                     
         switch (ADCON0 & MaskRead)   // quale porta analogica sta usando?
         {
            case EyeRf:                // Sensore IR Frontale Destro
                  EyeRfVal = ADRESH;   // solo il byte alto della lettura e' usato
                  ADCON0 &= MaskClear; // clear bit relativi alla porta
                  ADCON0 |= EyeLf;     // si imposta la successiva porta da leggere
                  FlagEye = 1;// la misura e' stata effettuata, si abilita la routine Eye 
         					  		// al controllo degli ostacoli, questa verra' eseguita una 
         					  		// volta e poi rimarra' ferma fino alla prossima lettura valida
                  break;

            case EyeLf:                // Sensore IR Frontale Sinistro
                  EyeLfVal = ADRESH;   // solo il byte alto della lettura e' usato
                  ADCON0 &= MaskClear; // clear bit relativi alla porta
                  ADCON0 |= EyeRl;     // si imposta la successiva porta da leggere
                  FlagEye = 1;// la misura e' stata effettuata, si abilita la routine Eye 
         					  		// al controllo degli ostacoli, questa verra' eseguita una 
         					  		// volta e poi rimarra' ferma fino alla prossima lettura valida
                  break;

            case EyeRl:                // Sensore IR Laterale Destro
                  EyeRlVal = ADRESH;   // solo il byte alto della lettura e' usato
                  ADCON0 &= MaskClear; // clear bit relativi alla porta
                  ADCON0 |= EyeLl;     // si imposta la successiva porta da leggere
                  FlagEye = 1;// la misura e' stata effettuata, si abilita la routine Eye 
         					  		// al controllo degli ostacoli, questa verra' eseguita una 
         					  		// volta e poi rimarra' ferma fino alla prossima lettura valida
                  break;

            case EyeLl:                // Sensore IR Laterale Sinistro
                  EyeLlVal = ADRESH;   // solo il byte alto della lettura e' usato
                  ADCON0 &= MaskClear; // clear bit relativi alla porta
                  ADCON0 |= FrR;       // si imposta la successiva porta da leggere
                  FlagEye = 1;// la misura e' stata effettuata, si abilita la routine Eye 
         					  		// al controllo degli ostacoli, questa verra' eseguita una 
         					  		// volta e poi rimarra' ferma fino alla prossima lettura valida
                  break;

            case FrR:                  // FotoResistenza Destra
                  FrRVal = ADRESH;     // solo il byte alto della lettura e' usato
                  ADCON0 &= MaskClear; // clear bit relativi alla porta
                  ADCON0 |= FrC;       // si imposta la successiva porta da leggere
                  FlagLight = 1;// la misura e' stata effettuata, si abilita la routine Light 
         					  	     // alla ricerca della luce, questa verra' eseguita una 
         					  		  // volta e poi rimarra' ferma fino alla prossima lettura valida
                  break;
                  
            case FrC:                  // FotoResistenza Centrale
                  FrCVal = ADRESH;     // solo il byte alto della lettura e' usato
                  ADCON0 &= MaskClear; // clear bit relativi alla porta
                  ADCON0 |= FrL;       // si imposta la successiva porta da leggere
                  FlagLight = 1;// la misura e' stata effettuata, si abilita la routine Light 
         					  	     // alla ricerca della luce, questa verra' eseguita una 
         					  		  // volta e poi rimarra' ferma fino alla prossima lettura valida
                  break;

            case FrL:                  // FotoResistenza Sinistra
                  FrLVal = ADRESH;     // solo il byte alto della lettura e' usato
                  ADCON0 &= MaskClear; // clear bit relativi alla porta
                  ADCON0 |= GasIn; 	   // si imposta la successiva porta da leggere
                  FlagLight = 1;// la misura e' stata effettuata, si abilita la routine Light 
         					  	     // alla ricerca della luce, questa verra' eseguita una 
         					  		  // volta e poi rimarra' ferma fino alla prossima lettura valida
                  break;
				
				case GasIn:        	      // gas
                  GasVal = ADRESH;   	// solo il byte alto della lettura e' usato
                  ADCON0 &= MaskClear; // clear bit relativi alla porta
                  ADCON0 |= EyeRf;     // ricomincia il giro
                  FlagGas = 1;  // la misura e' stata effettuata, si abilita la routine gas
         					  	     // alla ricerca del gas, questa verra' eseguita una 
         					  		  // volta e poi rimarra' ferma fino alla prossima lettura valida
         			FlagSound = 1;// con la stessa temporizzazione abilita anche la routine Sound
                  break;
				
            default: 
                                       // a default imposta EyeR
                  ADCON0 &= MaskClear; // clear bit relativi alla porta
                  ADCON0 |= EyeRf;     // si imposta la successiva porta da leggere
                  
                  break;
         }
         TimerAD = 0;     // resetta il timer 
         FlagAD = 0;      // e l'indicatore di stato     
                          // al prossimo giro del main  riaspettera'
   }                      // N mS e poi ricomincera' dallo step 1 

}

} //  ReadAD
/**************************************************************************************/

/*Bumpers  ****************************************************************************
Controllo dei sensori di collisione
*/

void Bumpers(void)
{

if (FlagBumpers) // routine disattiva
{
   /* disabilita i sensori per 1 Sec (debouncer), il timer e' incrementato
      dall'interrupt ogni mSec
   */
   if (TimerBumpers >= 1000) 
   {
      FlagBumpers=0; // riabilita la routine
   }
}
else
{
    if (BumperDx == 0) // controlla bumper destro
    {          
      FlagBumpers = 1;  // disattiva bumpers
      TimerBumpers = 0; // per 1 Sec
      Space2RunFlag = 0; // reset di qualsiasi routine di movimento
      
      // evita l'ostacolo a SX
      PathSeq [0] = 2;   // indietro n cm
      PathSeq [1] = 13;  // gira 45a SX 
      PathSeq [2] = 255; // cammina avanti a velocita' costante
      PathSeq [3] = 0;   // fine sequenza 
      PathSeqPointer = 0;// inizializza sequenza
    }
    
    if (BumperSx == 0 && !FlagBumpers) // bumper sinistro ma non bumper destro
    {      
      FlagBumpers = 1;  // disattiva bumpers
      TimerBumpers = 0; // per 1Sec 
      Space2RunFlag = 0; // reset di qualsiasi routine di movimento
      
      // evita l'ostacolo a DX
      PathSeq [0] = 2;   // indietro n cm
      PathSeq [1] = 12;  // gira 45a DX  
      PathSeq [2] = 255; // cammina avanti a velocita' costante
      PathSeq [3] = 0;   // fine sequenza 
      PathSeqPointer = 0;// inizializza sequenza
    }
}
} // Bumpers
/**************************************************************************************/
